import tester.*;

public class Examples implements Testable{
    
    // sample data to be used for all tests
    public ImageFile pic1 = new ImageFile("dog", 300, 200, "jpg");
    public ImageFile pic2 = new ImageFile("cat", 200, 200, "png");
    public ImageFile pic3 = new ImageFile("bird", 250, 200, "jpg");
    public ImageFile pic4 = new ImageFile("horse", 300, 300, "giff");
    public ImageFile pic5 = new ImageFile("goat", 100, 200, "giff");
    public ImageFile pic6 = new ImageFile("cow", 150, 200, "jpg");
    public ImageFile pic7 = new ImageFile("snake", 200, 300, "jpg");
    
    //empty list
    AList<ImageFile> mt= new MTList<ImageFile>();

    // picture list -- all pictures
    AList<ImageFile> piclistall = new ConsList<ImageFile>(pic1, 
        new ConsList<ImageFile>(pic2,
            new ConsList<ImageFile>(pic3, 
                new ConsList<ImageFile>(pic4, 
                    new ConsList<ImageFile>(pic5, 
                        new ConsList<ImageFile>(pic6, 
                            new ConsList<ImageFile>(pic7, mt))))))); 
      
  // picture list - short names (less than 4 characters)
  AList<ImageFile> piclistshortnames = new ConsList<ImageFile>(pic1, 
      new ConsList<ImageFile>(pic2, 
          new ConsList<ImageFile>(pic6, mt))); 
  
  // picture list - small size (< 40000)
  AList<ImageFile> piclistsmall = new ConsList<ImageFile>(pic5, 
      new ConsList<ImageFile>(pic6, mt));
  
  // picture list - small size (< 40000)
  AList<ImageFile> piclistsmall2 = new ConsList<ImageFile>(pic5, 
      new ConsList<ImageFile>(pic6, mt));

  // picture list -- large pictures
  AList<ImageFile> piclistlarge = new ConsList<ImageFile>(pic1, 
      new ConsList<ImageFile>(pic2,
          new ConsList<ImageFile>(pic3,mt))); 

  // rest all data to the original values before running a test
    public void resetData(){
      this.pic1 = new ImageFile("dog", 300, 200, "jpg");
      this.pic2 = new ImageFile("cat", 200, 200, "png");
      this.pic3 = new ImageFile("bird", 250, 200, "jpg");
      this.pic4 = new ImageFile("horse", 300, 300, "giff");
      this.pic5 = new ImageFile("goat", 100, 200, "giff");
      this.pic6 = new ImageFile("cow", 150, 200, "jpg");
      this.pic7 = new ImageFile("snake", 200, 300, "jpg");
      
      //empty list
      this.mt= new MTList<ImageFile>();
  
      // picture list -- all pictures
      this.piclistall = new ConsList<ImageFile>(pic1, 
          new ConsList<ImageFile>(pic2,
              new ConsList<ImageFile>(pic3, 
                  new ConsList<ImageFile>(pic4, 
                      new ConsList<ImageFile>(pic5, 
                          new ConsList<ImageFile>(pic6, 
                              new ConsList<ImageFile>(pic7, mt))))))); 
        
    // picture list - short names (less than 4 characters)
    this.piclistshortnames = new ConsList<ImageFile>(pic1, 
        new ConsList<ImageFile>(pic2, 
            new ConsList<ImageFile>(pic6, mt))); 
    
    // picture list - small size (< 40000)
    this.piclistsmall = new ConsList<ImageFile>(pic5, 
        new ConsList<ImageFile>(pic6, mt));
    }
    
    // run the test suite for the crop method 
    public void testCropMethod(Tester t) {
      // SETUP (for both tests)
      this.resetData();
      
      // APPLY THE METHOD
      // pic1.crop(...);
  
      // TEST THE EFFECT
      // t.test("crop1: ", pic1, new ImageFile(...));
      
      // APPLY THE METHOD
      // pic2.crop(...);
  
      // TEST THE EFFECT
      // t.test("crop2: ", pic2, new ImageFile(...));
    }
    
    public void tests(Tester t){
      testCropMethod(t);
    }
    
    public void go(){
      Tester tester = new Tester();
      tester.runTests(this);

      System.out.println("Invoking t.testReport: \n");      
      tester.testReport();   
      tester.fullTestReport();   
           
    }
      // hook to the outside world
    public static void main(String argv[]){
      Examples e = new Examples();
      
      // show the data used in the tests
      // ... included only for illustration --- not needed
      System.out.println("" + e.pic1);
      System.out.println("" + e.pic2);
            
      // report the test results
      e.go();
    }
    
  
  }