/*
                            +-------------------+
                            |                   |
                            v                   |
             +--------------------------+       |        
             |  AList<T>                |       |        
             +--------------------------+       |
	         | boolean contains(T that) |       |
             +--------------------------+       |        
                         |                      |
                        / \                     |
                        ---                     |
                         |                      |
           ---------------------------          |
           |                         |          |
    +-------------+          +---------------+  |
    | MTList<T>   |          | ConsList<T>   |  |
    +-------------+          +---------------+  |
    +-------------+     +----| T first       |  |
                        |    | AList<T> rest |--+  
                        |    +---------------+ 
	            		v
	            	   ...
                        |
                +---------------+    
                | ImageFile     |    
                +---------------+    
                | String name   |     
                | int    width  |      
                | int    height |      
                | String kind   |      
                +---------------+    

 */  

//to represent a list of objects.
interface AList<T>{

  // does this list contain the given object?
  boolean contains(T that);
}      


